"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserSchema = exports.PageTypeSchema = exports.PageInputSchema = exports.LayoutInputSchema = exports.HttpMethodSchema = exports.HttpInputSchema = exports.EventOptionTypeSchema = exports.EventInputSchema = exports.EventArgumentInputSchema = exports.DropDownComponentInputSchema = exports.ComponentInputSchema = exports.ButtonComponentTypeSchema = exports.AttributeInputSchema = exports.definedNonNullAnySchema = void 0;
const myzod = __importStar(require("myzod"));
const types_1 = require("../types");
exports.definedNonNullAnySchema = myzod.object({});
exports.AttributeInputSchema = myzod.object({
    key: myzod.string().optional().nullable(),
    val: myzod.string().optional().nullable()
});
exports.ButtonComponentTypeSchema = myzod.enum(types_1.ButtonComponentType);
exports.ComponentInputSchema = myzod.object({
    child: myzod.lazy(() => (0, exports.ComponentInputSchema)().optional().nullable()),
    childrens: myzod.array(myzod.lazy(() => (0, exports.ComponentInputSchema)().nullable())).optional().nullable(),
    event: myzod.lazy(() => (0, exports.EventInputSchema)().optional().nullable()),
    name: myzod.string(),
    type: exports.ButtonComponentTypeSchema
});
exports.DropDownComponentInputSchema = myzod.object({
    dropdownComponent: myzod.lazy(() => (0, exports.ComponentInputSchema)().optional().nullable()),
    getEvent: myzod.lazy(() => (0, exports.EventInputSchema)())
});
exports.EventArgumentInputSchema = myzod.object({
    name: myzod.string().min(5),
    value: myzod.string().pattern(/^foo/)
});
exports.EventInputSchema = myzod.object({
    arguments: myzod.array(myzod.lazy(() => (0, exports.EventArgumentInputSchema)())),
    options: myzod.array(exports.EventOptionTypeSchema).optional().nullable()
});
exports.EventOptionTypeSchema = myzod.enum(types_1.EventOptionType);
exports.HttpInputSchema = myzod.object({
    method: exports.HttpMethodSchema.optional().nullable(),
    url: exports.definedNonNullAnySchema
});
exports.HttpMethodSchema = myzod.enum(types_1.HttpMethod);
exports.LayoutInputSchema = myzod.object({
    dropdown: myzod.lazy(() => (0, exports.DropDownComponentInputSchema)().optional().nullable())
});
exports.PageInputSchema = myzod.object({
    attributes: myzod.array(myzod.lazy(() => (0, exports.AttributeInputSchema)())).optional().nullable(),
    date: exports.definedNonNullAnySchema.optional().nullable(),
    height: myzod.number(),
    id: myzod.string(),
    layout: myzod.lazy(() => (0, exports.LayoutInputSchema)()),
    pageType: exports.PageTypeSchema,
    postIDs: myzod.array(myzod.string()).optional().nullable(),
    show: myzod.boolean(),
    tags: myzod.array(myzod.string().nullable()).optional().nullable(),
    title: myzod.string(),
    width: myzod.number()
});
exports.PageTypeSchema = myzod.enum(types_1.PageType);
exports.UserSchema = myzod.object({
    __typename: myzod.literal('User').optional(),
    createdAt: exports.definedNonNullAnySchema.optional().nullable(),
    email: myzod.string().optional().nullable(),
    id: myzod.string().optional().nullable(),
    name: myzod.string().optional().nullable(),
    password: myzod.string().optional().nullable(),
    updatedAt: exports.definedNonNullAnySchema.optional().nullable()
});
