export declare type Maybe<T> = T | null;
export declare type InputMaybe<T> = Maybe<T>;
export declare type Exact<T extends {
    [key: string]: unknown;
}> = {
    [K in keyof T]: T[K];
};
export declare type MakeOptional<T, K extends keyof T> = Omit<T, K> & {
    [SubKey in K]?: Maybe<T[SubKey]>;
};
export declare type MakeMaybe<T, K extends keyof T> = Omit<T, K> & {
    [SubKey in K]: Maybe<T[SubKey]>;
};
/** All built-in and custom scalars, mapped to their actual values */
export declare type Scalars = {
    ID: string;
    String: string;
    Boolean: boolean;
    Int: number;
    Float: number;
    Date: any;
    URL: any;
};
export declare type AttributeInput = {
    key?: InputMaybe<Scalars['String']>;
    val?: InputMaybe<Scalars['String']>;
};
export declare enum ButtonComponentType {
    Button = "BUTTON",
    Submit = "SUBMIT"
}
export declare type ComponentInput = {
    child?: InputMaybe<ComponentInput>;
    childrens?: InputMaybe<Array<InputMaybe<ComponentInput>>>;
    event?: InputMaybe<EventInput>;
    name: Scalars['String'];
    type: ButtonComponentType;
};
export declare type DropDownComponentInput = {
    dropdownComponent?: InputMaybe<ComponentInput>;
    getEvent: EventInput;
};
export declare type EventArgumentInput = {
    name: Scalars['String'];
    value: Scalars['String'];
};
export declare type EventInput = {
    arguments: Array<EventArgumentInput>;
    options?: InputMaybe<Array<EventOptionType>>;
};
export declare enum EventOptionType {
    Reload = "RELOAD",
    Retry = "RETRY"
}
export declare type HttpInput = {
    method?: InputMaybe<HttpMethod>;
    url: Scalars['URL'];
};
export declare enum HttpMethod {
    Get = "GET",
    Post = "POST"
}
export declare type LayoutInput = {
    dropdown?: InputMaybe<DropDownComponentInput>;
};
export declare type PageInput = {
    attributes?: InputMaybe<Array<AttributeInput>>;
    date?: InputMaybe<Scalars['Date']>;
    height: Scalars['Float'];
    id: Scalars['ID'];
    layout: LayoutInput;
    pageType: PageType;
    postIDs?: InputMaybe<Array<Scalars['ID']>>;
    show: Scalars['Boolean'];
    tags?: InputMaybe<Array<InputMaybe<Scalars['String']>>>;
    title: Scalars['String'];
    width: Scalars['Int'];
};
export declare enum PageType {
    BasicAuth = "BASIC_AUTH",
    Lp = "LP",
    Restricted = "RESTRICTED",
    Service = "SERVICE"
}
export declare type User = {
    __typename?: 'User';
    createdAt?: Maybe<Scalars['Date']>;
    email?: Maybe<Scalars['String']>;
    id?: Maybe<Scalars['ID']>;
    name?: Maybe<Scalars['String']>;
    password?: Maybe<Scalars['String']>;
    updatedAt?: Maybe<Scalars['Date']>;
};
