"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserSchema = exports.PageTypeSchema = exports.PageInputSchema = exports.LayoutInputSchema = exports.HttpMethodSchema = exports.HttpInputSchema = exports.EventOptionTypeSchema = exports.EventInputSchema = exports.EventArgumentInputSchema = exports.DropDownComponentInputSchema = exports.ComponentInputSchema = exports.ButtonComponentTypeSchema = exports.AttributeInputSchema = void 0;
const yup = __importStar(require("yup"));
const types_1 = require("../types");
exports.AttributeInputSchema = yup.object({
    key: yup.string(),
    val: yup.string()
});
exports.ButtonComponentTypeSchema = yup.mixed().oneOf([types_1.ButtonComponentType.Button, types_1.ButtonComponentType.Submit]);
exports.ComponentInputSchema = yup.object({
    child: yup.lazy(() => (0, exports.ComponentInputSchema)()),
    childrens: yup.array().of(yup.lazy(() => (0, exports.ComponentInputSchema)())).optional(),
    event: yup.lazy(() => (0, exports.EventInputSchema)()),
    name: yup.string().defined(),
    type: exports.ButtonComponentTypeSchema.defined()
});
exports.DropDownComponentInputSchema = yup.object({
    dropdownComponent: yup.lazy(() => (0, exports.ComponentInputSchema)()),
    getEvent: yup.lazy(() => (0, exports.EventInputSchema)().defined())
});
exports.EventArgumentInputSchema = yup.object({
    name: yup.string().defined().min(5),
    value: yup.string().defined().matches(/^foo/)
});
exports.EventInputSchema = yup.object({
    arguments: yup.array().of(yup.lazy(() => (0, exports.EventArgumentInputSchema)().defined())).defined(),
    options: yup.array().of(exports.EventOptionTypeSchema.defined()).optional()
});
exports.EventOptionTypeSchema = yup.mixed().oneOf([types_1.EventOptionType.Reload, types_1.EventOptionType.Retry]);
exports.HttpInputSchema = yup.object({
    method: exports.HttpMethodSchema,
    url: yup.mixed().defined()
});
exports.HttpMethodSchema = yup.mixed().oneOf([types_1.HttpMethod.Get, types_1.HttpMethod.Post]);
exports.LayoutInputSchema = yup.object({
    dropdown: yup.lazy(() => (0, exports.DropDownComponentInputSchema)())
});
exports.PageInputSchema = yup.object({
    attributes: yup.array().of(yup.lazy(() => (0, exports.AttributeInputSchema)().defined())).optional(),
    date: yup.mixed(),
    height: yup.number().defined(),
    id: yup.string().defined(),
    layout: yup.lazy(() => (0, exports.LayoutInputSchema)().defined()),
    pageType: exports.PageTypeSchema.defined(),
    postIDs: yup.array().of(yup.string().defined()).optional(),
    show: yup.boolean().defined(),
    tags: yup.array().of(yup.string()).optional(),
    title: yup.string().defined(),
    width: yup.number().defined()
});
exports.PageTypeSchema = yup.mixed().oneOf([types_1.PageType.BasicAuth, types_1.PageType.Lp, types_1.PageType.Restricted, types_1.PageType.Service]);
exports.UserSchema = yup.object({
    __typename: yup.mixed().oneOf(['User', undefined]),
    createdAt: yup.mixed(),
    email: yup.string(),
    id: yup.string(),
    name: yup.string(),
    password: yup.string(),
    updatedAt: yup.mixed()
});
