import { z } from 'zod';
import { AttributeInput, ButtonComponentType, ComponentInput, DropDownComponentInput, EventArgumentInput, EventInput, EventOptionType, HttpInput, HttpMethod, LayoutInput, PageInput, PageType, User } from '../types';
declare type Properties<T> = Required<{
    [K in keyof T]: z.ZodType<T[K], any, T[K]>;
}>;
declare type definedNonNullAny = {};
export declare const isDefinedNonNullAny: (v: any) => v is definedNonNullAny;
export declare const definedNonNullAnySchema: z.ZodEffects<z.ZodAny, any, any>;
export declare const AttributeInputSchema: z.ZodObject<Properties<AttributeInput>>;
export declare const ButtonComponentTypeSchema: z.ZodNativeEnum<typeof ButtonComponentType>;
export declare const ComponentInputSchema: z.ZodObject<Properties<ComponentInput>>;
export declare const DropDownComponentInputSchema: z.ZodObject<Properties<DropDownComponentInput>>;
export declare const EventArgumentInputSchema: z.ZodObject<Properties<EventArgumentInput>>;
export declare const EventInputSchema: z.ZodObject<Properties<EventInput>>;
export declare const EventOptionTypeSchema: z.ZodNativeEnum<typeof EventOptionType>;
export declare const HttpInputSchema: z.ZodObject<Properties<HttpInput>>;
export declare const HttpMethodSchema: z.ZodNativeEnum<typeof HttpMethod>;
export declare const LayoutInputSchema: z.ZodObject<Properties<LayoutInput>>;
export declare const PageInputSchema: z.ZodObject<Properties<PageInput>>;
export declare const PageTypeSchema: z.ZodNativeEnum<typeof PageType>;
export declare const UserSchema: z.ZodObject<Properties<User>>;
export {};
