"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserSchema = exports.PageTypeSchema = exports.PageInputSchema = exports.LayoutInputSchema = exports.HttpMethodSchema = exports.HttpInputSchema = exports.EventOptionTypeSchema = exports.EventInputSchema = exports.EventArgumentInputSchema = exports.DropDownComponentInputSchema = exports.ComponentInputSchema = exports.ButtonComponentTypeSchema = exports.AttributeInputSchema = exports.definedNonNullAnySchema = exports.isDefinedNonNullAny = void 0;
const zod_1 = require("zod");
const types_1 = require("../types");
const isDefinedNonNullAny = (v) => v !== undefined && v !== null;
exports.isDefinedNonNullAny = isDefinedNonNullAny;
exports.definedNonNullAnySchema = zod_1.z.any().refine((v) => (0, exports.isDefinedNonNullAny)(v));
exports.AttributeInputSchema = zod_1.z.object({
    key: zod_1.z.string().nullish(),
    val: zod_1.z.string().nullish()
});
exports.ButtonComponentTypeSchema = zod_1.z.nativeEnum(types_1.ButtonComponentType);
exports.ComponentInputSchema = zod_1.z.object({
    child: zod_1.z.lazy(() => (0, exports.ComponentInputSchema)().nullish()),
    childrens: zod_1.z.array(zod_1.z.lazy(() => (0, exports.ComponentInputSchema)().nullable())).nullish(),
    event: zod_1.z.lazy(() => (0, exports.EventInputSchema)().nullish()),
    name: zod_1.z.string(),
    type: exports.ButtonComponentTypeSchema
});
exports.DropDownComponentInputSchema = zod_1.z.object({
    dropdownComponent: zod_1.z.lazy(() => (0, exports.ComponentInputSchema)().nullish()),
    getEvent: zod_1.z.lazy(() => (0, exports.EventInputSchema)())
});
exports.EventArgumentInputSchema = zod_1.z.object({
    name: zod_1.z.string().min(5),
    value: zod_1.z.string().regex(/^foo/, "message")
});
exports.EventInputSchema = zod_1.z.object({
    arguments: zod_1.z.array(zod_1.z.lazy(() => (0, exports.EventArgumentInputSchema)())),
    options: zod_1.z.array(exports.EventOptionTypeSchema).nullish()
});
exports.EventOptionTypeSchema = zod_1.z.nativeEnum(types_1.EventOptionType);
exports.HttpInputSchema = zod_1.z.object({
    method: exports.HttpMethodSchema.nullish(),
    url: exports.definedNonNullAnySchema
});
exports.HttpMethodSchema = zod_1.z.nativeEnum(types_1.HttpMethod);
exports.LayoutInputSchema = zod_1.z.object({
    dropdown: zod_1.z.lazy(() => (0, exports.DropDownComponentInputSchema)().nullish())
});
exports.PageInputSchema = zod_1.z.object({
    attributes: zod_1.z.array(zod_1.z.lazy(() => (0, exports.AttributeInputSchema)())).nullish(),
    date: exports.definedNonNullAnySchema.nullish(),
    height: zod_1.z.number(),
    id: zod_1.z.string(),
    layout: zod_1.z.lazy(() => (0, exports.LayoutInputSchema)()),
    pageType: exports.PageTypeSchema,
    postIDs: zod_1.z.array(zod_1.z.string()).nullish(),
    show: zod_1.z.boolean(),
    tags: zod_1.z.array(zod_1.z.string().nullable()).nullish(),
    title: zod_1.z.string(),
    width: zod_1.z.number()
});
exports.PageTypeSchema = zod_1.z.nativeEnum(types_1.PageType);
exports.UserSchema = zod_1.z.object({
    __typename: zod_1.z.literal('User').optional(),
    createdAt: exports.definedNonNullAnySchema.nullish(),
    email: zod_1.z.string().nullish(),
    id: zod_1.z.string().nullish(),
    name: zod_1.z.string().nullish(),
    password: zod_1.z.string().nullish(),
    updatedAt: exports.definedNonNullAnySchema.nullish()
});
