"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObjectTypeDefinitionBuilder = exports.isInput = exports.isNamedType = exports.isNonNullType = exports.isListType = void 0;
const isListType = (typ) => (typ === null || typ === void 0 ? void 0 : typ.kind) === 'ListType';
exports.isListType = isListType;
const isNonNullType = (typ) => (typ === null || typ === void 0 ? void 0 : typ.kind) === 'NonNullType';
exports.isNonNullType = isNonNullType;
const isNamedType = (typ) => (typ === null || typ === void 0 ? void 0 : typ.kind) === 'NamedType';
exports.isNamedType = isNamedType;
const isInput = (kind) => kind.includes('Input');
exports.isInput = isInput;
const ObjectTypeDefinitionBuilder = (useObjectTypes, callback) => {
    if (!useObjectTypes)
        return undefined;
    return node => {
        if (/^Query|Mutation|Subscription$/.test(node.name.value)) {
            return;
        }
        return callback(node);
    };
};
exports.ObjectTypeDefinitionBuilder = ObjectTypeDefinitionBuilder;
